/*--------------------------------------------------------------------.
| mbas.c							      |
| 								      |
| Copyright (c) 1997 Jonathan Hudson				      |
| 								      |
| You may distribute under the terms of either the GNU General Public |
| License or the Artistic License, as specified in the README file.   |
`--------------------------------------------------------------------*/
static char rcsid[] = "$Id: mbas.c,v 1.5 1997/11/15 14:33:02 jrh Rel $";

/*
 * $Log: mbas.c,v $
 * Revision 1.5  1997/11/15 14:33:02  jrh
 * reindented for release 1.05
 *
 * Revision 1.4  1997/10/12 20:41:40  jrh
 * indented source code
 *
 * Revision 1.3  1997/10/05 15:58:44  jrh
 * Changed some comments
 *
 * Revision 1.2  1997/10/04 19:55:03  jrh
 * tidied up for release v1.0
 *
 * Revision 1.1  1997/10/02 21:28:29  jrh
 * Initial revision
 *
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <qdos.h>

/*--------------------------------------------------------------------.
| Start a detached Minerva Multibasic. If you thought the Thing stuff |
| was arcane .... Still, at least Tony Firshman and Lau Reeves	      |
| understand the concept of documentation, which will come as some    |
| surprise to dedicated QDOS followers.				      |
`--------------------------------------------------------------------*/

/*
 * First code is 0x6008 + even text length
 * This code is at 10 + even text length
 */

static unsigned short jcode[] =
{
    0x2CBC, 0x0000, 0x0018,	/*  move.l  #$18,(a6) */
    0xDDFC, 0x0000, 0x0018,	/*  add.l   #$18,a6   */
    0x9BFC, 0x0000, 0x0018,	/*  sub.l   #$18,a5   */
    0x3478, 0x0154,		/*  move.w  $154,a2   */
    0x4EEA, 0x4000};		/*  jmp     $4000(a2) */

extern int io_open3 (char *, int, int);

/*------------------------------------------------------------------.
| Don't ask me how this works. I don't know. RTFM ... Laurence does |
`------------------------------------------------------------------*/

void StartMBJob (char *name, char *inp, char *cmd, int timo, int nchan,
		 char **devs)
{
    int jobid;
    void *jobaddr;
    struct JOBHEADER *jh;	/* ha ha */
    short elen, nlen;
    long codsiz;

    nlen = strlen (name);
    elen = (nlen + 1) & ~1;
    codsiz = 10 + elen + sizeof (jcode);
    jobid = mt_cjob (codsiz, 0xd00, NULL, 0, (char **)&jobaddr);
    if (jobid > 0)
    {
	void *stk;
	int chn;

	/* Set up our little code segment */

	*((short *) jobaddr) = 0x6008 + elen;
	*((short *) jobaddr + 1) = 0;
	*((short *) jobaddr + 2) = 0;
	*((short *) jobaddr + 3) = 0x4afb;
	*((short *) jobaddr + 4) = nlen;
	memcpy (((short *) jobaddr + 5), name, nlen);
	memcpy (((char *) jobaddr + 10 + elen), jcode, sizeof (jcode));
	jh = (((struct JOBHEADER *) jobaddr) - 1);

	if (inp && *inp)
	{
	    int inchan;
	    inchan = io_open3 (inp, 1, jobid);

	    if (inchan > 0)
	    {
		jh->jb_regs.jb_A0 = (addreg_t) inchan;
	    }
	}

	stk = (void *) jh->jb_regs.jb_A7;

	if (cmd && (nlen = strlen (cmd)))
	{
	    elen = (nlen + 1) & ~1;
	}
	else
	{
	    nlen = elen = 0;
	}

	elen = elen + (nchan << 2);

	if (elen)
	{
	    ((char *) stk) -= elen;
	    (void *) jh->jb_regs.jb_A7 = stk;
	}
	if (*((short *) stk)++ = nchan)
	{
	    short j;
	    for (j = 0; j < nchan; j++)
	    {
		chn = io_open3 (*(devs + j), (j == 0) ? 0 : 3, jobid);
		*((long *) stk)++ = chn;
	    }
	}
	*((short *) stk)++ = nlen;
	while (nlen--)
	{
	    *((char *) stk)++ = *cmd++;
	}

	if (nchan == 1 && (inp == NULL || *inp == '\0') &&
	    0 == strncmp (*devs, "con", 3))
	{
	    sd_bordr (chn, -1, 2, 1);
	    sd_clear (chn, -1);
	}
	mt_activ (jobid, 8, timo);
    }
}

/*-----------------------------------------------------.
| This bit works just like the bit above, only more so |
`-----------------------------------------------------*/

void vStartMBJob (char *name, char *inp, char *cmd, int timo, int n,...)
{
    int *l;
    l = &n;
    StartMBJob (name, inp, cmd, timo, n, (char **) (l + 1));
}

/*--------------------------------------------------------------------.
| Suppose I better explain some of this hackery ....		      |
| 								      |
| StartMBJob (jobName, prog, cmd$, syncflag, nchans, arrayofChanIDs); |
| 								      |
| and the varargs version					      |
| vStartMBJob (jobName, input_prog, cmd$, sync flag, no_chans, ...);  |
| 								      |
|                           the ... bit is channel IDS		      |
| e.g.								      |
| vStartMBJob (jobName, prog, cmd$, syncflag, nchans, chan1, chan2);  |
| 								      |
| Suppose it might have been nice to return the Job ID.		      |
| 								      |
| This is 'researched' from QView docs and examples.		      |
`--------------------------------------------------------------------*/
#ifdef TEST
int main (int ac, char **av)
{
    vStartMBJob ("MBasic", NULL, "Hello World", 0, 1, "con_300x120a40x40_1");
}

int (*_Cstart) (int, char **) = main;
#endif
