/*---------------------------------------------------------------------.
| qascade.c							       |
| 								       |
|  Copyright (c) 1997 Jonathan Hudson				       |
| 								       |
|  You may distribute under the terms of either the GNU General Public |
|  License or the Artistic License, as specified in the README file.   |
`---------------------------------------------------------------------*/

static char rcsid[] = "$Id: qascade.c,v 1.18 1999/05/07 17:43:13 jrh Exp $";

/*
 * $Log: qascade.c,v $
 * Revision 1.18  1999/05/07 17:43:13  jrh
 * *** empty log message ***
 *
 * Revision 1.17  1998/04/14 20:17:21  jrh
 * Fix the name :-)
 *
 * Revision 1.16  1998/03/15 20:28:01  jrh
 * updates for v1.09 and v1.10 (position + RC on command line)
 *
 * Revision 1.15  1998/01/05 17:43:03  jrh
 * Changed separators
 *
 * Revision 1.14  1997/12/07 20:24:59  jrh
 * added fi2 code
 *
 * Revision 1.13  1997/11/30 21:08:25  jrh
 * Added HOT_DO functions
 *
 * Revision 1.12  1997/11/15 14:33:02  jrh
 * reindented for release 1.05
 *
 * Revision 1.11  1997/11/15 14:25:27  jrh
 * yet more tidying up of pointer positioning
 *
 * Revision 1.10  1997/11/14 22:37:48  jrh
 * optimised reversed menus
 *
 * Revision 1.9  1997/11/14 20:30:15  jrh
 * bidirectional menus
 *
 * Revision 1.8  1997/11/13 22:09:35  jrh
 * *** empty log message ***
 *
 * Revision 1.7  1997/10/12 20:41:40  jrh
 * indented source code
 *
 * Revision 1.6  1997/10/12 20:38:05  jrh
 * Added text for separators and changed the colours a bit
 *
 * Revision 1.5  1997/10/12 17:52:15  jrh
 * Changes for 1.01 (priority)
 *
 * Revision 1.4  1997/10/04 20:41:44  jrh
 * Fixed line count
 *
 * Revision 1.3  1997/10/04 20:14:52  jrh
 * Yet more tidy ups
 *
 * Revision 1.2  1997/10/04 19:55:03  jrh
 * tidied up for release v1.0
 *
 * Revision 1.1  1997/10/02 21:28:29  jrh
 * Initial revision
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>
#include "qascade.h"

#define OS_QDOS  0
#define OS_MINNY 1
#define OS_SMSQE 2

char _prog_name[32] = "qascade v" VERSION;
char _version[] = VERSION;

static long ASWAKE (WM_wwork_t *, WM_litm_t *, WM_wstat_t *,
		    short, short, short, short);
static WM_action_t aswake = {JSR, wm_actli, ASWAKE};
//                            0 1 2 3 4   5 6 7 8 9 a b
unsigned char colarray[13] = {4,7,2,4,255,0,7,4,7,0,2,0};
char koff = 0;
static short ostype;

/*------------------------------------------------------------------------.
| What follows is pretty much the standard WM data areas, as we use two	  |
| window definitions (for the button and the menus, and there is all this |
| stupid outline stuff, we need two of many things.			  |
`------------------------------------------------------------------------*/

static WM_litm_t litm[] =	/* loose item */
{
    {0, 10,			/* xsize, ysize         size */
     2, 1,			/* xorg, yorg           and origin */
     0, 0,			/* xjst, yjst           justification */
     TYP_TEXT, K_WAKE,		/* type, skey           type and select key */
     NULL,			/* *pobj                pointer to object */
     0,				/* item                 item number */
     &aswake},			/* *pact                pointer to action */
    {-1}			/* end of array */
};

static WM_wstat_t ws =		/* window status area */
{
    NULL,			/* *wwork point back to work def */
    NULL,			/* *wdef this was wdef */
    0,				/* chid chan ID enclosing pointer */
    0, 0, 0,			/* swnr, xpos, ypos sub-window and ptr posn */
    0, 0,			/* kstk, kprs key stroke and press */
    0,				/* evnt event vector */
    0, 0, 0, 0,			/* xsiz, ysiz, xorg, yorg  */
    0, 0,			/* ptpsx, ptpsy pointer position (abs) */
    FORM_QL4, 0, 0,		/* wmode, 2 spare window mode and spare */
    NULL,			/* *ciact current item "action" */
    -1,				/* citem  current item */
    0, 0, 0,			/* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,			/* cihxs,ys, cihxo,yo   current item hit area */
    {0, 0, 0, 0, 0, 0, 0, 0}	/* litem[40] loose item status */
};

static WM_wstat_t wsb =		/* window status area */
{
    NULL,			/* *wwork point back to work def */
    NULL,			/* *wdef this was wdef */
    0,				/* chid chan ID enclosing pointer */
    0, 0, 0,			/* swnr, xpos, ypos sub-window and ptr posn */
    0, 0,			/* kstk, kprs key stroke and press */
    0,				/* evnt event vector */
    0, 0, 0, 0,			/* xsiz, ysiz, xorg, yorg  */
    0, 0,			/* ptpsx, ptpsy pointer position (abs) */
    FORM_QL4, 0, 0,		/* wmode, 2 spare window mode and spare */
    NULL,			/* *ciact current item "action" */
    -1,				/* citem  current item */
    0, 0, 0,			/* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,			/* cihxs,ys, cihxo,yo   current item hit area */
    {0, 0, 0, 0, 0, 0, 0, 0}	/* litem[40] loose item status */
};


static WM_wwork_t wwb =		/* window working definition */
{
    NULL,			/* *wstat pointer to status area */
    NULL,			/* *wscale this was pointer to WDEF */
    0,				/* chid channel ID */
    NULL,			/* *pprec pointer to pointer record */
    0,				/* psave pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    NULL,			/* *splst pointer to sprite list */
    0, 12,			/* xsize, ysize         size */
    2, 6,			/* xorg, yorg           and origin */
    0,				/* flag no clear + shadow */
    1, CL_BBORD, CL_MBACK,	/* borw, borc, papr border width/clr, paper */
    NULL,			/* *sprite  pointer to sprite */
    1, CL_MHIGH,		/* curw, curc current item width/clr */
    CL_MPUNAV, CL_MIUNAV, NULL, NULL,	/* uback, uink, *ublob, *upatt unavail */
    CL_BPAVBL, CL_BIAVBL, NULL, NULL,	/* aback, aink, *ablob, *apatt avail */
    CL_BPSLCT, CL_BISLCT, NULL, NULL,	/* sback, sink, *sblob, *spatt selected */
    NULL,			/* *help */
    0, 0, NULL,			/* ninfo, ninob, *pinfo info winds */
    1, litm,			/* nlitm, *plitm loose items */
    0, NULL			/* nappl  *pappl appl winds */
};

static WM_wwork_t ww =		/* window working definition */
{
    NULL,			/* *wstat pointer to status area */
    NULL,			/* *wscale this was pointer to WDEF */
    0,				/* chid channel ID */
    NULL,			/* *pprec pointer to pointer record */
    0,				/* psave pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    NULL,			/* *splst pointer to sprite list */
    512, 256,			/* xsize, ysize         size */
    0, 0,			/* xorg, yorg           and origin */
    NO_WCLEAR,			/* flag no clear + shadow */
    0, 0, 0,			/* borw, borc, papr border width/clr, paper */
    NULL,			/* *sprite  pointer to sprite */
    1, 0,			/* curw, curc current item width/clr */
    0, 0, NULL, NULL,		/* uback, uink, *ublob, *upatt unavail */
    0, 0, NULL, NULL,		/* aback, aink, *ablob, *apatt avail */
    0, 0, NULL, NULL,		/* sback, sink, *sblob, *spatt selected */
    NULL,			/* *help */
    0, 0, NULL,			/* ninfo, ninob, *pinfo info winds */
    0, NULL,			/* nlitm, *plitm loose items */
    0, NULL			/* nappl  *pappl appl winds */
};

/*-----------------------------------------------------------------.
| This table defines the keys in the menu definition file and some |
| constants associated with them				   |
`-----------------------------------------------------------------*/

static const STABLE stab[] =
{
    {TITLE, "TITLE"},
    {EXEC,  "EXEC"},
    {ETHG,  "ETHG"},
    {MBAS,  "MBAS"},
    {SBAS,  "SBAS"},
    {SEP,   "SEP"},
    {MENU,  "MENU"},
    {UNEM,  "MEND"},
    {COLS,  "COLS"},
    {JUMP,  "JUMP"},
    {HKEY,  "HKEY"},
    {FI2,   "FI2"},
    {AUTOK, "AUTOK"},
    {0, NULL},
};

/*---------------------------------------------------------------------------.
| If some error has occured, usually due to an error in the menu file	     |
| or the definition thereof, we should tell the user nicely. Novel concept!  |
| 									     |
| Not using sprintf is worth about 3K					     |
`---------------------------------------------------------------------------*/

static void bomb (long flag, long extra)
{
    typedef struct
    {
	long val;
	char *fmt;
    }
    ETABLE;

    static ETABLE tbl[] =
    {
	{-3, "Out of memory (need %d)"},
	{-7, "Can't load QASCADE_RC"},
	{-15, "QASCADE_RC error at line %d"},
	{-19, "Can't resolve QASCADE_RC"},
	{-21, "No Title for menu, QASCADE_RC line %d"},
	{0, NULL},
    };

    ETABLE *t;
    char buf[80];
    for (t = tbl; t->val; t++)
    {
	if (t->val == flag)
	{
	    char *p, *q;
	    q = stpcpy (buf, t->fmt);

	    if ((p = strchr (t->fmt, '%')))
	    {
		int n;

		n = p - t->fmt;

		if (*(p + 1) == 'd')
		{
		    itoa (extra, buf + n);
		    n = strlen (buf);
		    q = stpcpy (buf + n, p + 2);
		}
		else if (*(p + 1) == 's')
		{
		    q = stpcpy (buf + n, (char *) extra);
		    q = stpcpy (q, p + 2);
		}
	    }
	    *q++ = '\0';
	    wm_prpos (&ww, DEFXY);
	    wm_wdraw (&ww);
	    menu_choice (&ww, buf, 1, 0, "OK");
	    break;
	}
    }
    exit (flag);
}

/*-----------------------------------------------------------------------.
| Because we are a cstart=main program, we do not use the c68 memory	 |
| allocation routines. So define our own. The malloc/free used are those |
| from libmin, not libc.						 |
`-----------------------------------------------------------------------*/

void *xalloc (int i)
{
    void *p;
    if ((p = malloc (i)))
    {
	memset (p, '\0', i);
    }
    else
	bomb (-3, i);
    return p;
}

void xfree (void *q)
{
    if (q)
	free (q);
}

char *strdup (char *p)
{
    char *q;
    q = xalloc (strlen (p) + 1);
    strcpy (q, p);
    return q;
}

/*--------------------------.
| So we can redraw the menu |
`--------------------------*/

static long lit_reset (WM_wwork_t * wwk, short lit)
{
    wwk->wstat->litem[lit] = WSI_MKAV;	/* set make available */
    return wm_ldraw (wwk, -1);
}

/*-----------------------------------------------------------------------.
| Given a line from the RC file, we see if it equates to a known state.	 |
| Don't care if not, if might be a comment or blank (or a mistake)	 |
`-----------------------------------------------------------------------*/

static short destate (char *str)
{
    short res = 0;
    size_t slen;
    STABLE *s;
    char *r;

    if ((r = strchr (str, '\n')))
    {
	*r = 0;
	for (s = (STABLE *) stab; s->state; s++)
	{
	    if (strncmp (s->name, str, strlen (s->name)) == 0)
	    {
		res = s->state;
		break;
	    }
	}
    }
    return res;
}

/*-------------------------------------------------------------------.
| At one stage, there was a plan to have some cunning state table to |
| check the veracity of the RC file. Let the user do it.	     |
`-------------------------------------------------------------------*/

#define allowed(p1,p2) 1

/*----------------------------------------------------------------------------.
| If the user has defined sub-menus, then we assume there is a previously     |
| defined TITLE. We therefore need to recursively search though the current   |
| menu structure to match the new menu name with a previously defined title.  |
`----------------------------------------------------------------------------*/

void *findname (ITEMS * itm, char *name)
{
    void *res = NULL;
    ITEMS *p;

    for (p = itm; p && res == NULL; p = p->next)
    {
	if (p->l->act == TITLE)
	{
	    if (p->l->ptr)
	    {
		MENUS *m;
		m = (MENUS *) p->l->ptr;
		if ((res = findname (m->items, name)))
		{
		    break;
		}
	    }
	    else
	    {
		int n = strlen (name);
		if ((p->l->len == n + 4 +koff) &&
		    (strncmp (name, (char *) p->l->chrs + koff, n) == 0) &&
		    (strcmp ((char *) p->l->chrs + n + koff, " ...") == 0))
		{
		    res = p;
		    break;
		}
	    }
	}
    }
    return res;
}


/*------------------------------------------------------------------------.
| Split out the menu text and command (rest of the line) from a line from |
| the RC file. We just skip over the TAG, because we'll have already	  |
| recognised that.							  |
`------------------------------------------------------------------------*/

void split (char *a, char **b, char **c)
{
    for (; *a > ' ' && *a != ';' ; a++)
	;			/* skip the tag */

    if (*a == '\t' || *a == ';')
    {
	*b = a + 1;
	if (c && ((*c = strchr (*b, '\t')) || (*c = strchr (*b, ';'))))
	{
	    *(*c)++ = '\0';
	}
    }
}

ITEMS * new_item(char *s1, short *ns)
{
    ITEMS *newitm;
    
    *ns = strlen (s1);
    if(koff)
    {
        *ns += koff;
    }
                            
    newitm = xalloc (sizeof (ITEMS));
    newitm->l = xalloc (sizeof (MINFO) + (*ns) + 4);
    if(koff)
    {
        newitm->l->chrs[0] = newitm->l->chrs[1] = ' ';
    }
    strcpy ((char *) newitm->l->chrs+koff, s1);
    newitm->l->len = *ns;
    return newitm;
}

/*---------------------------------------------------------------------.
| Read the RC file and act accordingly, including calling create_menus |
| if the the user has defined some sub-menus. Isn't recursion fun !    |
`---------------------------------------------------------------------*/

static short mv = 0;

static void create_menus (int fd, MENUS * m, MENUS * top,
			  short state, short *lino)
{
    char str[128];
    short val;
    short done;
    char *s1, *s2;
    ITEMS *newitm = NULL, *mnuitm, *last = NULL;
    MENUS *mnu;
    size_t nl;

    for (done = 0; !done && (io_fline (fd, -1, str, sizeof (str)) >= 0);)
    {
	(*lino)++;
	if ((val = destate (str)))
	{
	    if (allowed (state, val))
	    {
		short ns;

		state = val;
		s1 = s2 = NULL;
		newitm = NULL;

		switch (val)
		{
                    case AUTOK:
                        if(top->height == 0)
                        {
                            koff = 2;
                        }
                        break;
		    case JUMP:
			mv = 1;
			break;
		    case COLS:
			split (str, &s1, NULL);
			if (s1)
			{
			    short i;
			    ns = strlen (s1);
			    if (ns > MAXCOL)
				ns = MAXCOL;
			    for (i = 0; i < ns; i++)
			    {
				char c;
				c = *(s1 + i) | ' ';

				switch (c)
				{
				    case 'b':
					*(colarray + i) = 0;
					break;
				    case 'r':
					*(colarray + i) = 2;
					break;
				    case 'g':
					*(colarray + i) = 4;
					break;
				    case 'w':
					*(colarray + i) = 7;
					break;
				    case 'y':
					*(colarray + i) = 255;
					break;
				}
			    }
			}
			break;
		    case TITLE:
			split (str, &s1, NULL);
			if (s1 == NULL)
			    bomb (-15, (int) (*lino));
                        newitm = new_item(s1, &ns);
			strcpy ((char *) newitm->l->chrs + ns, " ...");
			ns += 4;
			newitm->l->len = ns;
			newitm->l->act = TITLE;
			newitm->l->ptr = NULL;
			if (ns > m->width)
			    m->width = ns;
			m->height++;
			break;
		    case SEP:
			split (str, &s1, NULL);
			if (s1)
			{
			    nl = strlen (s1);
			    if (nl > m->width)
				m->width = nl + 2 + koff;
			}
			else
			{
			    nl = 0;
			}
			newitm = xalloc (sizeof (ITEMS));
			newitm->l = xalloc (sizeof (MINFO) + nl + 4);
			newitm->l->act = SEP;
			newitm->l->ptr = NULL;
			newitm->l->len = 0;
			if (nl)
			{
			    strcpy ((char *) newitm->l->chrs, s1);
			}
			m->height++;
			break;
		    case EXEC:
		    case ETHG:
		    case MBAS:
		    case SBAS:
		    case HKEY:
		    case FI2:
			if (((val == MBAS && ostype != OS_MINNY) ||
			     (val == SBAS && ostype != OS_SMSQE)) == 0)
			{
			    split (str, &s1, &s2);
			    if (s1 == NULL || s2 == NULL)
				bomb (-15, (int) *lino);

                            newitm = new_item(s1, &ns);
			    newitm->l->act = val;
			    newitm->l->ptr = strdup (s2);
			    if (ns > m->width)
				m->width = ns;
			    m->height++;
			}
			break;
		    case MENU:
			split (str, &s1, NULL);
			if (s1 == NULL)
			    bomb (-15, (int) *lino);
			mnu = xalloc (sizeof (MENUS));
			if ((mnuitm = findname (top->items, s1)))
			{
			    mnu->title = strdup (s1);
			    mnuitm->l->ptr = mnu;
			    mnu->width = strlen (mnu->title);
			    mnu->height = 0;
			    mnu->items = NULL;
			    create_menus (fd, mnu, top, TITLE, lino);
			}
			else
			{
			    bomb (-21, (int) *lino);
			}
			break;
		    case UNEM:
			done = 1;
			break;
		}
		if (newitm)
		{
		    if (last)
			last->next = newitm;
		    last = newitm;
		    if (m->items == NULL)
			m->items = newitm;
		}
	    }
	}
    }
}

/*-------------------------------------------------------------------.
| The callback for QPTR when the user clicks on the button. If we do |
| not have a button frame, then LMB can move the button.	     |
`-------------------------------------------------------------------*/

static long ASWAKE (WM_wwork_t * wwk, WM_litm_t * li, WM_wstat_t * wst,
		    short xpos, short ypos, short key, short event)
{
    if (event)
    {
	return PT__WAKE;	/* convert DO to WAKE */
    }
    if (wwk->flag)
    {
	short dx, dy;
	wwk->wstat->evnt |= PT_WMOVE;	/* set event bit for wm_chwin */
	wm_chwin (wwk, &dx, &dy);	/* move window */
    }
    return lit_reset (wwk, 0);	/* otherwise reset and return */
}

/*--------------------------------------------------------------------.
| For *BAS keys, we allow files or devices to be specificed for I/O.  |
| Here we parse the string and build up a vector of such file/device  |
| names								      |
`--------------------------------------------------------------------*/

char **checkdev (char *p, short flag, short *pnc)
{
    char *q;
    short nc;
    char **devs = NULL;

    if (p && *p)
    {
	for (nc = 0, q = p; (q = strchr (q, ',')); q++, nc++)
	    ;			/* Counter loop */

	if (nc || flag)
	{
	    char **pd;
	    pd = devs = xalloc ((flag + nc) * sizeof (char *));

	    for (nc = 0; q = strchr (p, ','); nc++)
	    {
		*q++ = 0;
		if (nc || flag)
		{
		    *pd++ = p;
		}
		p = q;
	    }
	    *pd = p;
	}
    }
    *pnc = nc + flag;
    return devs;
}

/*--------------------------------------------------------------------.
| Load the RC file. This is done at program startup and when ever the |
| the user ESCs on the button.					      |
`--------------------------------------------------------------------*/

MENUS *LoadRCfile (QD_text_t * but, char *s)
{
    MENUS *top = NULL;
    int fd;
    short lino = 0;
    char *senv = NULL;
    
    if(s == NULL)
    {
        s = senv = getenv ("QASCADE_RC");
    }
    
    if (s && *s)
    {
	if ((fd = io_open (s, 0)) > 0)
	{
	    top = xalloc (sizeof (MENUS));
	    top->title = xalloc (but->len + 1);
	    memcpy (top->title, (char *) but->chrs, but->len);
	    *(top->title + but->len) = 0;
	    top->width = but->len;
	    top->height = 0;
	    top->items = NULL;
	    create_menus (fd, top, top, TITLE, &lino);
	    io_close (fd);
	}
	xfree (senv);
    }
    else
    {
	bomb (-19, 0);
    }
    return top;
}

/*-------------------------------------------------------------------------.
| Free up the data structures and associated memory. Called recursively as |
| we descend the menu tree. Note we are careful not to shoot ourselves in  |
| the foot by blowing away memory we need to reference later on :-) Ouch.  |
`-------------------------------------------------------------------------*/

static void freemenus (MENUS * m)
{
    ITEMS *p, *q;

    for (p = m->items; p;)
    {
	switch (p->l->act)
	{
	    case TITLE:
		if (p->l->ptr)
		{
		    MENUS *m;
		    m = (MENUS *) p->l->ptr;
		    freemenus (m);
		    xfree (p->l);
		}
		break;
	    case SEP:
		xfree (p->l);
		break;
	    case EXEC:
	    case ETHG:
	    case SBAS:
	    case MBAS:
		xfree (p->l->ptr);
		xfree (p->l);
		break;
	}
	q = p;
	p = p->next;
	xfree (q);
    }
    xfree (m->title);
    xfree (m);
}


/*-------------------------------------------------------------------------.
| At last, after all that infrastructure nonsense, the real program	   |
| As we are a cstart = main (i.e. glorified assembler) program, we	   |
| use QDOS I/O and treat the passed command line differently from a normal |
| C program.								   |
`-------------------------------------------------------------------------*/
typedef union
{
    char txt[4];
    long x;
}
ALIGN;

#if 0
void showql (char *ctl,...)
{
    static int f = 0;
    va_list va;
    char t[80];


    if(f == 0) f = io_open("win2_tmp_ql.log", NEW_OVER);
    va_start (va, ctl);
    vsprintf (t, ctl, va);
    va_end (va);
    io_sstrg (f, -1, t, strlen (t));
}
#endif

static ALIGN smsq = {"SMSQ"};
static ALIGN jsl1 = {"JSL1"};

int main (int ac, char **av)
{
    static QD_TEXTI (BUTTON, "Qasqade");
    MENUS *top;
    int ch;
    char *mp;
    short nc;
    char *sp;
    char *rcfile = NULL;
    
    QD_text_t *but = (QD_text_t *) & BUTTON;
    short defp = 126;

    sp = *(av + 1);
    nc = *((short *) sp);

    sp += (2 + (nc << 2));

    if (nc = *((short *) sp))
    {
        char *pa;

        /*----------------------------------------------.
        | Check for config file as part of command line |
        `----------------------------------------------*/
        
	but = (QD_text_t *) sp;
        if((pa = strchr((char *)but->chrs, '<')) != NULL)
        {
            int n;
            
            char *p = pa-1;
            while(*p <= ' ') p--;
            but->len = (int)(p - (char*)but->chrs)+1;
            while(*pa < 'A') pa++;
            n = nc - (int)(pa - (char*)but->chrs);
            rcfile = malloc(n+1);
            memcpy(rcfile, pa, n);
            *(rcfile+n) = 0;
        }
    }

    if (*((long *) (_sys_var)) == smsq.x)
    {
	ostype = OS_SMSQE;
    }
    else
    {
	char *pt;
	pt = *((char **) (_sys_var + 0x7c));
	if ((*((short *) (pt + 0x44)) == 4) &&
	    (*((long *) (pt + 0x46)) == jsl1.x))
	{
	    ostype = OS_MINNY;
	}
	else
	    ostype = OS_QDOS;
    }

    wsb.wwork = &wwb;
    wwb.wstat = &wsb;

    ws.wwork = &ww;
    ww.wstat = &ws;

    wwb.xsize = 6 * (but->len + 1);

    litm[0].xsize = wwb.xsize - 4;
    litm[0].pobj = but;

    ww.chid = wwb.chid = io_open ("con", 0);
    if (!(wm_findv (wwb.chid)))
    {
	return -1;
    }

    if ((top = LoadRCfile (but, rcfile)))
    {

	if (bt_prpos (&wwb))
	{
	    defp = 1;
	    wwb.flag = 2;
	    wm_prpos (&wwb, DEFXY);
	}

	wm_wdraw (&wwb);
	wm_swinf (&wwb, 0, 0);

	while (1)
	{
	    int n, ioff;
	    MINFO *i;
	    mt_prior (-1, defp);
	    wm_rptr (&wwb);
	    mt_prior (-1, 8);
	    /*------------------------------------------.
	    | The user has done something to our button |
	    `------------------------------------------*/

	    if ((wsb.evnt & PT_WAKE))
	    {
		/*----------------------------------------------------.
		| If she WAKEs it, then we have to unset the wdef and |
		| create one that can fit in the menus.		      |
		`----------------------------------------------------*/

		short act;
		short defarg = 0;
		short nc = 0;
		char eargs[80];
		char *p, *q, prog[80], *args, **devs = NULL;

		mp = NULL;
		iop_flim (wwb.chid, -1, (WM_wsiz_t *) & ww.xsize);
		wm_unset (&wwb);
		ww.xorg = wwb.xorg;
		ww.yorg = wwb.wstat->ptpsy;
		wm_prpos (&ww, DEFXY);
		wm_wdraw (&ww);
		ww.wstat->ptpsx = wwb.xorg;
		ww.wstat->ptpsy = wwb.yorg;
		menu (&ww, top, (void **)&mp);

		/*--------------------------------------------------.
		| If the user wants some action, then 'mp' will be  |
		| non NULL and point to the MINFO item for the menu |
		| option selected.				    |
		`--------------------------------------------------*/

		if (mp)
		{
		    i = (MINFO *) mp;
		    act = i->act;

		    n = strcspn ((char *) i->ptr, ";\t");

		    /*----------------------------------------.
		    | See if modifiable arguments are allowed |
		    `----------------------------------------*/

		    if (i->ptr && *(char *) i->ptr == '?')
		    {
			ioff = 1;
		    }
		    else
		    {
			ioff = 0;
		    }

		    defarg = (n != strlen ((char *) i->ptr));

		    if (defarg)
		    {
			args = (char *) i->ptr + n + 1;
			p = strncpy (prog, (char *) i->ptr + ioff, n - ioff);
			*(p + n - ioff) = 0;
		    }
		    else
		    {
			if (i->ptr)
			{
			    p = strcpy (prog, (char *) i->ptr + ioff);
			}
			else
			{
			    p = NULL;
			    *prog = 0;
			}
			args = NULL;
		    }

		    /*---------------------------------.
		    | And prompt for them if necessary |
		    `---------------------------------*/

		    if (ioff && p)
		    {
			char *s, prompt[80];
			s = stpcpy (prompt, "Arguments for ");
			strcpy (s, p);
			if (args)
			{
			    strcpy (eargs, args);
			}
			else
			{
			    *eargs = 0;
			}
			if (menu_text (&ww, prompt, eargs, 60) == -1)
			{
			    act = 0;
			}
			else
			    args = eargs;
		    }
		}
		else
		{
		    act = 0;
		}

		/*---------------------------------------------------.
		| we have now resolved what we are to do and any     |
		| arguments the action requires. So we'll reset the  |
		| window definition and redraw the button to tidy up |
		| the screen prior to actually doing it.	     |
		`---------------------------------------------------*/

		wm_unset (&ww);
		wwb.xorg = wwb.wstat->ptpsx - wwb.xorg;
		wwb.yorg = wwb.wstat->ptpsy - wwb.yorg;
		if (mv == 0)
		{
		    wm_prpos (&wwb, wwb.wstat->ptpsx, wwb.wstat->ptpsy);
		}
		else
		{
		    bt_free ();
		    bt_prpos (&wwb);
		}
		wm_wdraw (&wwb);
		lit_reset (&wwb, 0);

		/*-------------------------------------------.
		| As the lemmings so cutely said: "Lets Go!' |
		`-------------------------------------------*/
		switch (act)
		{
		    case EXEC:
			fork (p, args);
			break;
		    case ETHG:
			TryThing (p, args, -1, (void **)&q, 0);
			break;
		    case MBAS:
			devs = checkdev (prog, 0, &nc);
			StartMBJob ("MBasic", prog, args, 0, nc, devs);
			break;
		    case SBAS:
			devs = checkdev (prog, 1, &nc);
			TryThing ("sbasic", args, -1, (void **)&q, nc, devs);
			break;
		    case HKEY:
			BurnMe(p);
			break;
		    case FI2:
			fi2exec(p, wwb.chid);
			break;
		}
		if (devs)
		    xfree (devs);
	    }
	    else if ((wsb.evnt & PT_CAN))
	    {
		/*-----------------------------------------------.
		| Reparse the RC file. If OK, throw away the old |
		|                    menu definitions		 |
		`-----------------------------------------------*/
		MENUS *nt;
		if ((nt = LoadRCfile (but, rcfile)))
		{
		    freemenus (top);
		    top = nt;
		}
	    }
	}
    }
    else
	bomb (-7, 0);
}

int (*_Cstart) () = main;
